# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetEvpnTopologiesResult',
    'AwaitableGetEvpnTopologiesResult',
    'get_evpn_topologies',
    'get_evpn_topologies_output',
]

@pulumi.output_type
class GetEvpnTopologiesResult:
    """
    A collection of values returned by getEvpnTopologies.
    """
    def __init__(__self__, id=None, org_evpn_topologies=None, org_id=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if org_evpn_topologies and not isinstance(org_evpn_topologies, list):
            raise TypeError("Expected argument 'org_evpn_topologies' to be a list")
        pulumi.set(__self__, "org_evpn_topologies", org_evpn_topologies)
        if org_id and not isinstance(org_id, str):
            raise TypeError("Expected argument 'org_id' to be a str")
        pulumi.set(__self__, "org_id", org_id)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="orgEvpnTopologies")
    def org_evpn_topologies(self) -> Sequence['outputs.GetEvpnTopologiesOrgEvpnTopologyResult']:
        return pulumi.get(self, "org_evpn_topologies")

    @property
    @pulumi.getter(name="orgId")
    def org_id(self) -> str:
        return pulumi.get(self, "org_id")


class AwaitableGetEvpnTopologiesResult(GetEvpnTopologiesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetEvpnTopologiesResult(
            id=self.id,
            org_evpn_topologies=self.org_evpn_topologies,
            org_id=self.org_id)


def get_evpn_topologies(org_id: Optional[str] = None,
                        opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetEvpnTopologiesResult:
    """
    This data source provides the list of Org Evpn Topologies

    EVPN allows an alternative but more efficient LAN architecture utilizing VxLAN / MP-BGP to separate the control plane (MAC / IP Learning) from the forwarding plane.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_junipermist as junipermist

    org_evpn_topologies = junipermist.org.get_evpn_topologies(org_id="15fca2ac-b1a6-47cc-9953-cc6906281550")
    ```
    """
    __args__ = dict()
    __args__['orgId'] = org_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('junipermist:org/getEvpnTopologies:getEvpnTopologies', __args__, opts=opts, typ=GetEvpnTopologiesResult).value

    return AwaitableGetEvpnTopologiesResult(
        id=pulumi.get(__ret__, 'id'),
        org_evpn_topologies=pulumi.get(__ret__, 'org_evpn_topologies'),
        org_id=pulumi.get(__ret__, 'org_id'))
def get_evpn_topologies_output(org_id: Optional[pulumi.Input[str]] = None,
                               opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetEvpnTopologiesResult]:
    """
    This data source provides the list of Org Evpn Topologies

    EVPN allows an alternative but more efficient LAN architecture utilizing VxLAN / MP-BGP to separate the control plane (MAC / IP Learning) from the forwarding plane.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_junipermist as junipermist

    org_evpn_topologies = junipermist.org.get_evpn_topologies(org_id="15fca2ac-b1a6-47cc-9953-cc6906281550")
    ```
    """
    __args__ = dict()
    __args__['orgId'] = org_id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('junipermist:org/getEvpnTopologies:getEvpnTopologies', __args__, opts=opts, typ=GetEvpnTopologiesResult)
    return __ret__.apply(lambda __response__: GetEvpnTopologiesResult(
        id=pulumi.get(__response__, 'id'),
        org_evpn_topologies=pulumi.get(__response__, 'org_evpn_topologies'),
        org_id=pulumi.get(__response__, 'org_id')))
