# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetPsksResult',
    'AwaitableGetPsksResult',
    'get_psks',
    'get_psks_output',
]

@pulumi.output_type
class GetPsksResult:
    """
    A collection of values returned by getPsks.
    """
    def __init__(__self__, id=None, name=None, org_id=None, org_psks=None, role=None, ssid=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if org_id and not isinstance(org_id, str):
            raise TypeError("Expected argument 'org_id' to be a str")
        pulumi.set(__self__, "org_id", org_id)
        if org_psks and not isinstance(org_psks, list):
            raise TypeError("Expected argument 'org_psks' to be a list")
        pulumi.set(__self__, "org_psks", org_psks)
        if role and not isinstance(role, str):
            raise TypeError("Expected argument 'role' to be a str")
        pulumi.set(__self__, "role", role)
        if ssid and not isinstance(ssid, str):
            raise TypeError("Expected argument 'ssid' to be a str")
        pulumi.set(__self__, "ssid", ssid)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="orgId")
    def org_id(self) -> str:
        return pulumi.get(self, "org_id")

    @property
    @pulumi.getter(name="orgPsks")
    def org_psks(self) -> Sequence['outputs.GetPsksOrgPskResult']:
        return pulumi.get(self, "org_psks")

    @property
    @pulumi.getter
    def role(self) -> Optional[str]:
        return pulumi.get(self, "role")

    @property
    @pulumi.getter
    def ssid(self) -> Optional[str]:
        return pulumi.get(self, "ssid")


class AwaitableGetPsksResult(GetPsksResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetPsksResult(
            id=self.id,
            name=self.name,
            org_id=self.org_id,
            org_psks=self.org_psks,
            role=self.role,
            ssid=self.ssid)


def get_psks(name: Optional[str] = None,
             org_id: Optional[str] = None,
             role: Optional[str] = None,
             ssid: Optional[str] = None,
             opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetPsksResult:
    """
    This data source provides the list Org Psks.

    A multi PSK (Pre-Shared Key) is a feature that allows the use of multiple PSKs for securing network connections.\\
    It provides a simple and comprehensive way to onboard client devices without relying on client mac addresses.\\
    Each psk has its own key name, which can be used for user-level accountability, key rotation, and visibility in the management platform. It supports the creation, rotation, and auto-expiration of psks, and allows vlan assignment and role assignment for dynamic per-user policies.\\
    Multi PSKs create virtual broadcast domains and can be used for end-user onboarding via authenticated sso login.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_junipermist as junipermist

    psks_vip = junipermist.org.get_psks(org_id="15fca2ac-b1a6-47cc-9953-cc6906281550",
        name="psk_one",
        role="vip",
        ssid="psk_ssid")
    ```
    """
    __args__ = dict()
    __args__['name'] = name
    __args__['orgId'] = org_id
    __args__['role'] = role
    __args__['ssid'] = ssid
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('junipermist:org/getPsks:getPsks', __args__, opts=opts, typ=GetPsksResult).value

    return AwaitableGetPsksResult(
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'),
        org_id=pulumi.get(__ret__, 'org_id'),
        org_psks=pulumi.get(__ret__, 'org_psks'),
        role=pulumi.get(__ret__, 'role'),
        ssid=pulumi.get(__ret__, 'ssid'))
def get_psks_output(name: Optional[pulumi.Input[Optional[str]]] = None,
                    org_id: Optional[pulumi.Input[str]] = None,
                    role: Optional[pulumi.Input[Optional[str]]] = None,
                    ssid: Optional[pulumi.Input[Optional[str]]] = None,
                    opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetPsksResult]:
    """
    This data source provides the list Org Psks.

    A multi PSK (Pre-Shared Key) is a feature that allows the use of multiple PSKs for securing network connections.\\
    It provides a simple and comprehensive way to onboard client devices without relying on client mac addresses.\\
    Each psk has its own key name, which can be used for user-level accountability, key rotation, and visibility in the management platform. It supports the creation, rotation, and auto-expiration of psks, and allows vlan assignment and role assignment for dynamic per-user policies.\\
    Multi PSKs create virtual broadcast domains and can be used for end-user onboarding via authenticated sso login.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_junipermist as junipermist

    psks_vip = junipermist.org.get_psks(org_id="15fca2ac-b1a6-47cc-9953-cc6906281550",
        name="psk_one",
        role="vip",
        ssid="psk_ssid")
    ```
    """
    __args__ = dict()
    __args__['name'] = name
    __args__['orgId'] = org_id
    __args__['role'] = role
    __args__['ssid'] = ssid
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('junipermist:org/getPsks:getPsks', __args__, opts=opts, typ=GetPsksResult)
    return __ret__.apply(lambda __response__: GetPsksResult(
        id=pulumi.get(__response__, 'id'),
        name=pulumi.get(__response__, 'name'),
        org_id=pulumi.get(__response__, 'org_id'),
        org_psks=pulumi.get(__response__, 'org_psks'),
        role=pulumi.get(__response__, 'role'),
        ssid=pulumi.get(__response__, 'ssid')))
