# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetRftemplatesResult',
    'AwaitableGetRftemplatesResult',
    'get_rftemplates',
    'get_rftemplates_output',
]

@pulumi.output_type
class GetRftemplatesResult:
    """
    A collection of values returned by getRftemplates.
    """
    def __init__(__self__, id=None, org_id=None, org_rftemplates=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if org_id and not isinstance(org_id, str):
            raise TypeError("Expected argument 'org_id' to be a str")
        pulumi.set(__self__, "org_id", org_id)
        if org_rftemplates and not isinstance(org_rftemplates, list):
            raise TypeError("Expected argument 'org_rftemplates' to be a list")
        pulumi.set(__self__, "org_rftemplates", org_rftemplates)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="orgId")
    def org_id(self) -> str:
        return pulumi.get(self, "org_id")

    @property
    @pulumi.getter(name="orgRftemplates")
    def org_rftemplates(self) -> Sequence['outputs.GetRftemplatesOrgRftemplateResult']:
        return pulumi.get(self, "org_rftemplates")


class AwaitableGetRftemplatesResult(GetRftemplatesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetRftemplatesResult(
            id=self.id,
            org_id=self.org_id,
            org_rftemplates=self.org_rftemplates)


def get_rftemplates(org_id: Optional[str] = None,
                    opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetRftemplatesResult:
    """
    This data source provides the list of RF Templates.

    The RF Templates can be used to define Wireless Access Points radio configuration, and can be assigned to the sites

    ## Example Usage

    ```python
    import pulumi
    import pulumi_junipermist as junipermist

    templates = junipermist.org.get_rftemplates(org_id="15fca2ac-b1a6-47cc-9953-cc6906281550")
    ```
    """
    __args__ = dict()
    __args__['orgId'] = org_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('junipermist:org/getRftemplates:getRftemplates', __args__, opts=opts, typ=GetRftemplatesResult).value

    return AwaitableGetRftemplatesResult(
        id=pulumi.get(__ret__, 'id'),
        org_id=pulumi.get(__ret__, 'org_id'),
        org_rftemplates=pulumi.get(__ret__, 'org_rftemplates'))
def get_rftemplates_output(org_id: Optional[pulumi.Input[str]] = None,
                           opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetRftemplatesResult]:
    """
    This data source provides the list of RF Templates.

    The RF Templates can be used to define Wireless Access Points radio configuration, and can be assigned to the sites

    ## Example Usage

    ```python
    import pulumi
    import pulumi_junipermist as junipermist

    templates = junipermist.org.get_rftemplates(org_id="15fca2ac-b1a6-47cc-9953-cc6906281550")
    ```
    """
    __args__ = dict()
    __args__['orgId'] = org_id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('junipermist:org/getRftemplates:getRftemplates', __args__, opts=opts, typ=GetRftemplatesResult)
    return __ret__.apply(lambda __response__: GetRftemplatesResult(
        id=pulumi.get(__response__, 'id'),
        org_id=pulumi.get(__response__, 'org_id'),
        org_rftemplates=pulumi.get(__response__, 'org_rftemplates')))
